-- Copyright (c) 2011 Cloudera, Inc. All rights reserved.
--
-- Version 7 of the CMF schema. Migration code to be applied on top of the
-- previous version.
--
-- Creates tables for users and user roles to support multiple SCM users

update SCHEMA_VERSION set VERSION=7;

create table USERS (
    USER_ID bigint not null,
    USER_NAME varchar(255) not null,
    PASSWORD_HASH varchar(255) not null,
    PASSWORD_SALT bigint not null,
    primary key (USER_ID)
) engine=InnoDB;

create table USER_ROLES (
    USER_ROLE_ID bigint not null,
    USER_ID bigint not null,
    USER_ROLE varchar(255) not null,
    primary key (USER_ROLE_ID)
) engine=InnoDB;

alter table USER_ROLES 
    add index FK_USER_ROLE (USER_ID), 
    add constraint FK_USER_ROLE 
    foreign key (USER_ID) 
    references USERS (USER_ID);
